<template>
  <transition name="fly">
    <div
      v-if="menuOpened"
      class="account-menu"
      :style="style"
      :class="themeClasses"
    >
      <div
        class="menu-section info-section"
        :class="[themeClasses, `member-${account.realLevel}`]"
      >
        <span class="account-level">{{ account.levelTitle }}</span>
        <span class="account-name">{{ account.name }}</span>
      </div>

      <div class="menu-section main-menu" :class="themeClasses">
        <button @click.prevent.stop="goToRecordsPage()" class="menu-button">
          {{ $t("account.menu.reservationRecords") }}
        </button>
        <button @click.prevent.stop="goToPreorderPage()" class="menu-button">
          {{ $t("account.menu.preorder") }}
        </button>
        <!-- <button
          @click.prevent.stop="showLoginMessage()"
          class="menu-button"
          v-if="account.levelTitle !== $t('account.levelTitle.V')"
        >
          {{ $t("account.menu.cardDetail", { level: account.levelTitle }) }}
        </button> -->
      </div>

      <div class="menu-section logout-section" v-if="!account.fromApp">
        <button @click="logout()" class="menu-button logout-button">
          {{ $t("account.menu.logout") }}
        </button>
      </div>
    </div>
  </transition>
</template>

<script>
import { mapState, mapActions, mapGetters } from "vuex";

export default {
  computed: {
    ...mapState("account", ["account", "menuOpened", "menuPosition"]),
    ...mapGetters("theme", ["themeClasses"]),
    style() {
      return {
        left: this.menuPosition.left + "px",
        top: this.menuPosition.top + "px"
      };
    }
  },

  methods: {
    ...mapActions("account", [
      "closeAccountMenu",
      "logout"
      // "showLoginMessage"
    ]),
    ...mapActions("routes", ["updateUpdatedTime"]),

    clickHandler(e) {
      if (this.menuOpened) {
        e.preventDefault();
        e.stopPropagation();
        this.closeAccountMenu();
      }
    },

    goToRecordsPage() {
      this.$router.push({ name: "ReservationRecords" });
      this.closeAccountMenu();
    },

    goToPreorderPage() {
      this.$router.push({ name: "PreorderRecords" });
      this.updateUpdatedTime();
      this.closeAccountMenu();
    }
  },

  mounted() {
    window.addEventListener("click", this.clickHandler);
  },

  destroyed() {
    window.removeEventListener("click", this.clickHandler);
  }
};
</script>

<style lang="scss" scoped>
.account-menu {
  position: absolute;
  z-index: 3;
  line-height: 52px;
  background-color: $color-white;
  border: 1px $color-pigeon-grey solid;
  border-radius: 2px;
  box-sizing: border-box;
  width: 252px;
  transform: translateX(-216px);
  font-size: 14px;

  &:before {
    content: "";
    position: absolute;
    left: 216px;
    top: -5px;
    background-color: $color-white;
    border-style: solid;
    border-width: 1px;
    border-color: $color-pigeon-grey $color-pigeon-grey transparent transparent;
    width: 10px;
    height: 10px;
    transform: rotateZ(-45deg);
  }

  &.theme-vip-member {
    background-color: $color-gold-100;
    border-color: $color-gold-300;

    &:before {
      background-color: $color-gold-100;
      border-color: $color-gold-300 $color-gold-300 transparent transparent;
    }
  }
}

.main-menu {
  padding: 10px 0;
}

.menu-section {
  position: relative;
}

.info-section {
  padding-left: 60px;
}

.info-section:before {
  content: "";
  position: absolute;
  top: 0;
  left: 0;
  width: 60px;
  height: 100%;
  // background-image: url("/static/images/ic-member-general.svg");
  background-size: 22px 22px;
  background-repeat: no-repeat;
  background-position: center center;
}

// .info-section.theme-vip-member:before {
//   background-image: url("/static/images/ic-member-vip.svg") !important;
// }

// .info-section.theme-map-member:before {
//   background-image: url("/static/images/ic-member-map.svg");
// }
.info-section.member-0 {
  &::before {
    background-image: url("/static/images/ic-member-map.svg");
  }
}

.info-section.member-S,
.info-section.member-N {
  &::before {
    background-image: url("/static/images/ic-member-general.svg");
  }
}

.info-section.member-V {
  &:before {
    background-image: url("/static/images/ic-member-vip.svg");
  }
}

.menu-section {
  border-bottom: 1px $color-sky-grey solid;

  &:last-child {
    border: none;
  }

  &.theme-vip-member {
    border-color: $color-skm-gold;
  }
}

.menu-button {
  padding: 0 0 0 60px;
  display: inline-block;
  width: 100%;
  border: none;
  text-align: left;
  background: transparent;
  cursor: pointer;

  &:hover {
    background-color: #f3f4f5;
  }
}

.theme-vip-member {
  .menu-button:hover {
    background-color: rgba(184, 163, 117, 0.2);
  }
}

.logout-section .menu-button {
  padding: 0;
  text-align: center;
}

.account-name {
  font-weight: bold;
}

.fly-enter-active,
.fly-leave-active {
  transition: all 0.2s;
}

.fly-enter,
.fly-leave-to {
  opacity: 0;
  margin-top: -10px;
}
</style>
